/*
 * blueMail offline mail reader
 * miscellaneous routines (global)

 Copyright (c) 1996 Toth Istvan <stoty@vma.bme.hu>
 Copyright (c) 1998 William McBrine <wmcbrine@clark.net>
 Copyright (c) 1998 Ingo Brueckl <ib@wupperonline.de>

 Distributed under the GNU General Public License.
 For details, see the file COPYING in the parent directory. */

#include <dirent.h>

#include "bmail.h"

// takes off the whitespace from the end of a string
char *cropesp (char *st)
{
  char *p;

  for (p = st + strlen(st) - 1; p > st && (*p == ' ' || *p == '\t'); p--);

  *++p = '\0';
  return st;
}

char *strdupplus (const char *original)
{
  char *tmp = NULL;

  if (original)
  {
    tmp = new char[strlen(original) + 1];
    strcpy(tmp, original);
  }

  return tmp;
};

char *findBaseName(const char *fileName)
{
        int c, d;
        static char tmp[13];

        for (c = 0; (fileName[c] != '.') && (fileName[c]); c++);

        for (d = 0; d < c; d++)
                tmp[d] = tolower(fileName[d]);
        tmp[d] = '\0';

        return tmp;
};

char *stripre(char *subject)
{
        if (!strncasecmp(subject, "re: ", 4))
                subject += 4;
        return subject;
}

void clearDirectory (const char *DirName)
{
  DIR *Dir;
  struct dirent *entry;

  if ((Dir = opendir(DirName)))
  {
    if (mychdir(DirName) == 0)
      while ((entry = readdir(Dir)))
        if (entry->d_name[0] != '.') remove(entry->d_name);
    closedir(Dir);
  }
}

// to avoid segmentation faults
size_t slen (const char *s)
{
  return (s ? strlen(s) : 0);
}

int mkfname (char *dest, const char *dir, const char *file)
{
  char format[14];

#ifdef __MSDOS__
  #define FORMAT  "%%.%lus/%%s"
#else
  #define FORMAT  "%%.%us/%%s"
#endif

  sprintf(format, FORMAT, MYMAXPATH - strlen(file) - 2);
  return sprintf(dest, format, dir, file);
}
