/*
 * blueMail offline mail reader
 * color handling and default color pairs

 Copyright (c) 1998 William McBrine <wmcbrine@clark.net>
 Copyright (c) 1998 Ingo Brueckl <ib@wupperonline.de>

 Distributed under the GNU General Public License.
 For details, see the file COPYING in the parent directory. */

#include "interfac.h"

chtype Color::defcolor[] =
{
  /*  0 */ COL(COLOR_WHITE, COLOR_BLACK),
  /*  1 */ COL(COLOR_BLUE, COLOR_BLACK) | A_BOLD,
  /*  2 */ COL(COLOR_MAGENTA, COLOR_BLACK),
  /*  3 */ COL(COLOR_WHITE, COLOR_BLACK) | A_BOLD,
  /*  4 */ COL(COLOR_YELLOW, COLOR_BLACK) | A_BOLD,
  /*  5 */ COL(COLOR_WHITE, COLOR_BLUE) | A_BOLD,
  /*  6 */ COL(COLOR_YELLOW, COLOR_BLUE) | A_BOLD,
  /*  7 */ COL(COLOR_BLUE, COLOR_BLACK) | A_BOLD,
  /*  8 */ COL(COLOR_YELLOW, COLOR_BLACK) | A_BOLD,
  /*  9 */ COL(COLOR_CYAN, COLOR_BLACK) | A_BOLD,
  /* 10 */ COL(COLOR_BLUE, COLOR_BLACK) | A_BOLD,
  /* 11 */ COL(COLOR_RED, COLOR_BLACK),
  /* 12 */ COL(COLOR_WHITE, COLOR_BLACK) | A_BOLD,
  /* 13 */ COL(COLOR_GREEN, COLOR_BLACK) | A_BOLD,
  /* 14 */ COL(COLOR_YELLOW, COLOR_BLACK) | A_BOLD,
  /* 15 */ COL(COLOR_WHITE, COLOR_BLACK) | A_BOLD,
  /* 16 */ COL(COLOR_BLACK, COLOR_CYAN),
  /* 17 */ COL(COLOR_WHITE, COLOR_RED) | A_BOLD,
  /* 18 */ COL(COLOR_YELLOW, COLOR_RED) | A_BOLD,
  /* 19 */ COL(COLOR_CYAN, COLOR_BLUE) | A_BOLD,
  /* 20 */ COL(COLOR_WHITE, COLOR_BLUE),
  /* 21 */ COL(COLOR_YELLOW, COLOR_BLUE) | A_BOLD,
  /* 22 */ COL(COLOR_WHITE, COLOR_BLUE) | A_BOLD,
  /* 23 */ COL(COLOR_YELLOW, COLOR_BLUE) | A_BOLD,
  /* 24 */ COL(COLOR_GREEN, COLOR_BLUE) | A_BOLD,
  /* 25 */ COL(COLOR_YELLOW, COLOR_BLUE) | A_BOLD,
  /* 26 */ COL(COLOR_MAGENTA, COLOR_BLUE) | A_BOLD,
  /* 27 */ COL(COLOR_YELLOW, COLOR_BLUE) | A_BOLD,
  /* 28 */ COL(COLOR_WHITE, COLOR_BLUE) | A_BOLD,
  /* 29 */ COL(COLOR_BLACK, COLOR_CYAN),
  /* 30 */ COL(COLOR_WHITE, COLOR_BLACK),
  /* 31 */ COL(COLOR_YELLOW, COLOR_BLACK),
  /* 32 */ COL(COLOR_WHITE, COLOR_BLACK),
  /* 33 */ COL(COLOR_BLUE, COLOR_BLACK) | A_BOLD,
  /* 34 */ COL(COLOR_GREEN, COLOR_BLACK) | A_BOLD,
  /* 35 */ COL(COLOR_YELLOW, COLOR_MAGENTA) | A_BOLD,
  /* 36 */ COL(COLOR_WHITE, COLOR_CYAN) | A_BOLD,
  /* 37 */ COL(COLOR_GREEN, COLOR_CYAN) | A_BOLD,
  /* 38 */ COL(COLOR_BLUE, COLOR_CYAN),
  /* 39 */ COL(COLOR_BLUE, COLOR_CYAN),
  /* 40 */ COL(COLOR_BLACK, COLOR_CYAN),
  /* 41 */ COL(COLOR_GREEN, COLOR_CYAN) | A_BOLD,
  /* 42 */ COL(COLOR_BLUE, COLOR_CYAN),
  /* 43 */ COL(COLOR_WHITE, COLOR_CYAN),
  /* 44 */ COL(COLOR_YELLOW, COLOR_CYAN) | A_BOLD,
  /* 45 */ COL(COLOR_CYAN, COLOR_BLUE) | A_BOLD,
  /* 46 */ COL(COLOR_YELLOW, COLOR_BLUE) | A_BOLD,
  /* 47 */ COL(COLOR_GREEN, COLOR_BLUE) | A_BOLD,
  /* 48 */ COL(COLOR_WHITE, COLOR_BLUE) | A_BOLD,
  /* 49 */ COL(COLOR_YELLOW, COLOR_BLUE) | A_BOLD,
  /* 50 */ COL(COLOR_YELLOW, COLOR_BLUE) | A_BOLD,
  /* 51 */ COL(COLOR_CYAN, COLOR_BLACK) | A_BOLD,
  /* 52 */ COL(COLOR_BLUE, COLOR_BLACK),
  /* 53 */ COL(COLOR_BLUE, COLOR_BLACK) | A_BOLD,
  /* 54 */ COL(COLOR_WHITE, COLOR_BLACK) | A_BOLD,
  /* 55 */ COL(COLOR_GREEN, COLOR_BLACK) | A_BOLD,
  /* 56 */ COL(COLOR_MAGENTA, COLOR_BLACK),
  /* 57 */ COL(COLOR_YELLOW, COLOR_BLACK) | A_BOLD,
  /* 58 */ COL(COLOR_WHITE, COLOR_BLACK) | A_BOLD,
  /* 59 */ COL(COLOR_YELLOW, COLOR_BLUE) | A_BOLD,
  /* 60 */ COL(COLOR_WHITE, COLOR_BLUE) | A_BOLD,
  /* 61 */ COL(COLOR_CYAN, COLOR_BLUE) | A_BOLD,
  /* 62 */ COL(COLOR_BLACK, COLOR_CYAN),
  /* 63 */ COL(COLOR_BLUE, COLOR_BLACK) | A_BOLD,
  /* 64 */ COL(COLOR_RED, COLOR_BLACK),
  /* 65 */ COL(COLOR_WHITE, COLOR_BLACK) | A_BOLD,
  /* 66 */ COL(COLOR_YELLOW, COLOR_BLACK) | A_BOLD,
  /* 67 */ COL(COLOR_WHITE, COLOR_BLACK) | A_BOLD,
  /* 68 */ COL(COLOR_BLACK, COLOR_CYAN),
  /* 69 */ COL(COLOR_WHITE, COLOR_WHITE) | A_BOLD,       // is BLACK on BLACK!
};

Color::Color ()
{
  for (int i = colorFIRST; i <= colorLAST; i++)
    if (bm.resourceObject->get(i))
      defcolor[i - colorFIRST] = colors(bm.resourceObject->get(i));

  color = defcolor;
}

chtype Color::col (chtype f, chtype b)
{
  /* remember: we defined BLACK on BLACK as color pair WHITE on WHITE */
  if (f == COLOR_BLACK && b == COLOR_BLACK)
    return COLOR_PAIR((COLOR_WHITE << 3) + COLOR_WHITE);

  /* WHITE on WHITE (as user color string) is the terminal's default color */
  if (f == COLOR_WHITE && b == COLOR_WHITE)
    return COLOR_PAIR((COLOR_BLACK << 3) + COLOR_BLACK);

  return COLOR_PAIR((f << 3) + b);
}

/* analyze a <foreground color>,<background color>,<attribute> color string */
chtype Color::colors (const char *colorstring)
{
  static struct
  {
    char *color;
    chtype value;
  } colormap[] = {{"BLACK", COLOR_BLACK}, {"BLUE", COLOR_BLUE},
                  {"GREEN", COLOR_GREEN}, {"CYAN", COLOR_CYAN},
                  {"RED", COLOR_RED}, {"MAGENTA", COLOR_MAGENTA},
                  {"YELLOW", COLOR_YELLOW}, {"WHITE", COLOR_WHITE}};
  char *pos, *part;
  static char result[8];
  int len;
  chtype c[3] = {COLOR_WHITE, COLOR_BLACK, A_NORMAL};

  pos = (char *) colorstring;

  for (int i = 0; i < 3; i++)
    if (*pos)
    {
      while (*pos == ' ' || *pos == '\t') pos++;

      part = pos;
      len = 0;

      while (*pos && *pos != ',')
      {
        pos++;
        len++;
      }

      if (len > 7) len = 0;
      else strncpy(result, part, len);
      result[len] = '\0';

      switch (i)
      {
        case 0:
        case 1:
          for (int j = 0; j < 8; j++)
            if (strcasecmp(result, colormap[j].color) == 0)
            {
              c[i] = colormap[j].value;
              break;
            }
          break;
        case 2:
          if (strcasecmp(result, "BOLD") == 0)
          {
            c[i] = A_BOLD;
            break;
          }
          if (strcasecmp(result, "REVERSE") == 0)
          {
#ifdef __FIXCURSES__
            c[2] = c[0];
            c[0] = c[1];
            c[1] = c[2];
            c[i] = A_NORMAL;
#else
            c[i] = A_REVERSE;
#endif
            break;
          }
      }

      if (*pos == ',') pos++;
    }

  return col(c[0], c[1]) | c[2];
}

#ifdef __FIXCURSES__
chtype Color::colormode (const chtype color, const chtype mode)
{
  chtype fg, bg, bold;

  fg = PAIR_NUMBER(color) >> 3;
  bg = PAIR_NUMBER(color) & 7;
  bold = color & A_BOLD;

  if (mode == A_REVERSE) return COL(bg, fg) | bold;

  if (mode == A_STANDOUT)
  {
    if (fg == COLOR_WHITE && bg == COLOR_WHITE) return color ^ A_BOLD;

    if (fg == COLOR_BLACK && bg == COLOR_WHITE)
      return COL(COLOR_WHITE, COLOR_BLACK) | bold;

    if (bg == COLOR_WHITE) return COL(fg, COLOR_BLACK) | bold;

    if (bold) return COL(COLOR_BLACK, COLOR_WHITE);
    else return COL(bg, COLOR_WHITE) | ((bg == COLOR_BLACK) ? A_BOLD : A_NORMAL);
  }

  return color | mode;
}
#endif
