/*
 * blueMail offline mail reader
 * color handling and default color pairs

 Copyright (c) 1996 John Zero <john@graphisoft.hu>
 Copyright (c) 1998 William McBrine <wmcbrine@clark.net>
 Copyright (c) 1998 Ingo Brueckl <ib@wupperonline.de>

 Distributed under the GNU General Public License.
 For details, see the file COPYING in the parent directory. */

#ifndef COLOR_H
#define COLOR_H

#ifdef __PDCURSES__
  #define __FIXCURSES__
#endif

#define COL(f, b) COLOR_PAIR((f << 3) + b)

#define C_MBACK         color[0]        // Main screen background
#define C_MBORDER       color[1]        // Main screen border
#define C_MSEPBOTT      color[2]        // Main screen separator (bottom)
#define C_HELPDESCR     color[3]        // Help descriptions
#define C_HELPKEYS      color[4]        // Help keys
#define C_HELPBORDER    color[5]        // Help border
#define C_HELPTEXT      color[6]        // Help text
#define C_WELCBORDER    color[7]        // Welcome border
#define C_WELCHEADER    color[8]        // Welcome header
#define C_WELCTEXT      color[9]        // Welcome text
#define C_ADDRLIST      color[10]       // Addressbook list
#define C_ADDRBORDER    color[11]       // Addressbook border
#define C_ADDRTOPTEXT   color[12]       // Addressbook top text
#define C_ADDRHEADER    color[13]       // Addressbook header
#define C_ADDRKEYS      color[14]       // Addressbook (help) keys
#define C_ADDRDESCR     color[15]       // Addressbook (help) description
#define C_ADDRINP       color[16]       // Addressbook input        --UNUSED--
#define C_WARNTEXT      color[17]       // Warning text
#define C_WARNKEYS      color[18]       // Warning text hilighted keys
#define C_LLISTUNRD     color[19]       // Letter list Unread
#define C_LLISTREAD     color[20]       // Letter list Read
#define C_LLBORDER      color[21]       // Letter list border
#define C_LLTOPTEXT     color[22]       // Letter list top border text
#define C_LLAREA        color[23]       // Letter list areaname
#define C_LLHEADER      color[24]       // Letter list header
#define C_LLFROMUSER    color[25]       // Letter list from user
#define C_LLTOUSER      color[26]       // Letter list to user
#define C_SAVEBOXBORDER color[27]       // Save box border
#define C_SAVEBOXHEADER color[28]       // Save box header
#define C_SAVEBOXINP    color[29]       // Save box input
#define C_LTEXT         color[30]       // Letter text
#define C_LQTEXT        color[31]       // Letter quoted text
#define C_LTAGLINE      color[32]       // Letter tagline
#define C_LTEARLINE     color[33]       // Letter tearline
#define C_LORIGIN       color[34]       // Letter origin
#define C_LBOTTLINE     color[35]       // Letter bottom (status) line
#define C_LHTEXT        color[36]       // Letter header (text)
#define C_LHMSGNUM      color[37]       // Letter header MSGNUM
#define C_LHFROM        color[38]       // Letter header FROM
#define C_LHTO          color[39]       // Letter header TO
#define C_LHSUBJ        color[40]       // Letter header SUBJECT
#define C_LHDATE        color[41]       // Letter header DATE
#define C_LHBORDER      color[42]       // Letter header border
#define C_LHFLAGS       color[43]       // Letter header flags
#define C_LHFLAGSHI     color[44]       // Letter header flags high
#define C_PLIST         color[45]       // Packet list
#define C_PLBORDER      color[46]       // Packet list border
#define C_PLHEADER      color[47]       // Packet list header
#define C_LALIST        color[48]       // Little area list
#define C_LALBORDER     color[49]       // Little area border
#define C_LALHEADER     color[50]       // Little area header
#define C_ALISTUNRD     color[51]       // Area list Unread
#define C_ALISTREAD     color[52]       // Area list Read
#define C_ALBORDER      color[53]       // Area list border
#define C_ALTOPTEXT     color[54]       // Area list top border texts
#define C_ALHEADER      color[55]       // Area list header
#define C_ALREPLY       color[56]       // Area list reply area
#define C_ALINFODESCR   color[57]       // Area list info win description
#define C_ALINFOTEXT    color[58]       // Area list info win text
#define C_REPBOXBORDER  color[59]       // Reply box border
#define C_REPBOXDESCR   color[60]       // Reply box description
#define C_REPBOXTEXT    color[61]       // Reply box text
#define C_REPBOXINP     color[62]       // Reply box input
#define C_TAGBOXLIST    color[63]       // Tagline box list
#define C_TAGBOXBORDER  color[64]       // Tagline box border
#define C_TAGBOXTTEXT   color[65]       // Tagline box top border text
#define C_TAGBOXKEYS    color[66]       // Tagline box keys
#define C_TAGBOXDESCR   color[67]       // Tagline box keys description
#define C_TAGBOXINP     color[68]       // Tagline box input
#define C_SHADOW        color[69]       // Shadow for all windows

class Color
{
  static chtype defcolor[];

  chtype col(chtype, chtype);
  chtype colors(const char *);

public:

  Color();
#ifdef __FIXCURSES__
  /* support for MSDOS PDCurses broken A_REVERSE and A_STANDOUT */
  chtype colormode(const chtype, const chtype);
#endif
};

extern const chtype *color;

#endif
