/*
 * blueMail offline mail reader
 * version number and name #define'd, as well as protos for mysystem.cc

 Copyright (c) 1998 William McBrine <wmcbrine@clark.net>
 Copyright (c) 1998 Ingo Brueckl <ib@wupperonline.de>

 Distributed under the GNU General Public License.
 For details, see the file COPYING in the parent directory. */

/* This is a separate file, so it can be included by source files under
bluemail/, without also including curses.h. */

#ifndef MYSYSTEM_H
#define MYSYSTEM_H

#define BM_NAME "blueMail"
#define BM_MAJOR 0
#define BM_MINOR 01
#define BM_TOP_N "%s"
#define BM_IS_WHAT "Offline Mail Reader"
#define BM_TOP_V "%d.%02d"
#define BM_TOPHEADER BM_TOP_N " " BM_IS_WHAT " " BM_TOP_V

#define MYMAXPATH 256
#define MYMAXLINE 128

#if defined(__MSDOS__) || defined(__EMX__)
  extern char *canonize(const char *);
#else
  #define canonize(x) x
#endif

// Some of the functions normally used by blueMail don't exist in EMX,
// but are available under other names:
#ifdef __EMX__
  #define strcasecmp stricmp
  #define strncasecmp strnicmp
  extern "C"
  {
    int _chdir2(__const__ char *);
    char *_getcwd2(char *, int);
  }
  #define mychdir _chdir2
  #define mygetcwd _getcwd2
#else
  #define mychdir chdir
  #define mygetcwd getcwd
#endif

extern int mysystem(const char *);
extern void mytmpnam(char *);

#endif
